﻿// Copyright 2011 L'Express de Toronto Inc.
// June 14, 2011
// Written by Kasyan Servetsky
// http://www.kasyan.ho.com.ua
// e-mail: askoldich@yahoo.com
//==========================================================================================================================
if (app.documents.length == 0) ErrorExit("Please open a document and try again.");
// globals	titre.principal.mince
var gScriptName = "Titre";
var gScriptVersion = "3.1";
//~ app.insertLabel("Kas_" + gScriptName + gScriptVersion, ""); // clear settings
var gDoc = app.activeDocument;
var gSet = GetSettings();
var gSelection = gDoc.selection;
var gTextFrame, gTitreObj, gSubtitreObj;








`
if (gSelection.length != 1) ErrorExit("One text frame or some text should be selected, or the cursor should be inserted into the text.");
// check paragraph styles if exist
var gTitreParStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal");
if (!gTitreParStyle == null) ErrorExit("Paragraph style \"titre.principal\" doesn't exist.");
var gTitreMinceParStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal.mince");
if (!gTitreMinceParStyle == null) ErrorExit("Paragraph style \"titre.principal.mince\" doesn't exist.");
var gSubtitreParStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.surtitre");
if (!gSubtitreParStyle == null) ErrorExit("Paragraph style \"titre.surtitre\" doesn't exist.");

if (gSelection[0].constructor.name == "TextFrame") { // a text frame is selected
	gTextFrame = gSelection[0];
	gText = gSelection[0].texts[0];
}
else if (gSelection[0].constructor.name == "InsertionPoint" || // some text is selected or the cursor is placed in the text
	gSelection[0].constructor.name == "Character" ||
	gSelection[0].constructor.name == "Word" ||
	gSelection[0].constructor.name == "TextStyleRange" ||
	gSelection[0].constructor.name == "Line" ||
	gSelection[0].constructor.name == "Paragraph" ||
	gSelection[0].constructor.name == "TextColumn" ||
	gSelection[0].constructor.name == "Text")
	{
		gText = gSelection[0].parentStory.texts[0];
	}
else if (gSelection[0].constructor.name == "Cell") { // a cell is selected
	gText = gSelection[0].parent.parent.parentStory.texts[0];
}
else if (gSelection[0].constructor.name == "Table") { // a table is selected
	gText = gSelection[0].parent.parentStory.texts[0];
}
else {
	ErrorExit("One text frame or some text should be selected, or the cursor should be inserted into the text.");
}
 
if (gText.contents == "") ErrorExit("The selection contains no text."); // text frame is empty

if (gText.constructor.name == "Text") {
	var gStory = gText.parentStory; // get the story
	gTextFrame = gStory.textContainers[0];
}
else {
	ErrorExit("Can't find the story.", true);
}

GetTitres();
CreateDialog();

//================================================= FUNCTIONS  ============================================================
function Main() {
	var pars, par, smallTf, xmlEl, parStyle;
	if (gTitreObj != undefined || gSubtitreObj != undefined) { // a header(s) already exist
		if (gSet.keepExistingHeaders) { // keep existing frame
			if (gTitreObj != undefined && gTitreObj.isValid) {
				app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
				app.findGrepPreferences.findWhat = ".+";
				app.findGrepPreferences.appliedParagraphStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal");
				app.changeGrepPreferences.changeTo = gSet.titre;
				var foundTitrePrincipal = gStory.changeGrep();
	
				if (foundTitrePrincipal.length == 0) {
					app.findGrepPreferences.appliedParagraphStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal.mince");
					foundTitrePrincipal = gStory.changeGrep();
				}

			}
			if (gSubtitreObj != undefined && gSubtitreObj.isValid) {
				app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
				app.findGrepPreferences.findWhat = ".+";
				app.findGrepPreferences.appliedParagraphStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.surtitre");
				app.changeGrepPreferences.changeTo = gSet.subtitre;
				gStory.changeGrep();
			}
			return;
		}
		else { // remove frame
			RemoveSmallFrame();
		}
	}

	// create new frame
	var gb = gTextFrame.geometricBounds;
	var smallTextFrame = gDoc.textFrames.add({ geometricBounds:[gb[0]-gSet.height, gb[1], gb[0], gb[3]] });
	var text = smallTextFrame.texts[0];
	
	if (gSet.radioBtnSelected == 1) {
		text.insertionPoints[0].contents = SpecialCharacters.FRAME_BREAK;
		text.insertionPoints[0].contents = gSet.titre;
		text.paragraphs[0].appliedParagraphStyle = (gSet.mince) ? gTitreMinceParStyle : gTitreParStyle;
		
		if (gSet.subtitre != "") {
			text.insertionPoints[0].contents = gSet.subtitre + "\r";
			text.paragraphs[0].appliedParagraphStyle = gSubtitreParStyle;
		}
	}
	else {
		if (gSet.subtitre != "") {
			text.insertionPoints[0].contents = SpecialCharacters.FRAME_BREAK;
			text.insertionPoints[0].contents = "\r" + gSet.subtitre;
			text.paragraphs.lastItem().appliedParagraphStyle = gSubtitreParStyle;
		}
		else {
			text.insertionPoints[0].contents = SpecialCharacters.FRAME_BREAK;
		}
	
		text.insertionPoints[0].contents = gSet.titre;
		text.paragraphs[0].appliedParagraphStyle = (gSet.mince) ? gTitreMinceParStyle : gTitreParStyle;
	}
	
	smallTextFrame.fit(FitOptions.FRAME_TO_CONTENT);
	var gb1 = smallTextFrame.geometricBounds;
	smallTextFrame.geometricBounds = [ gb[0]-(gb1[2]-gb1[0])-gSet.space, gb[1], gb[0]-gSet.space, gb[3] ];
	smallTextFrame.nextTextFrame = gTextFrame;
	
	if (text.parentStory.associatedXMLElement == null) text.parentStory.autoTag();

	try {
		if (gSet.radioBtnSelected == 1) {
			if (gSet.subtitre == "") {
				text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.principal"), text.paragraphs[0].characters.itemByRange(text.paragraphs[0].characters[0], text.paragraphs[0].characters[text.paragraphs[0].characters.length-2]));	
			}
			else {
				text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.surtitre"), text.paragraphs[0].characters.itemByRange(text.paragraphs[0].characters[0], text.paragraphs[0].characters[text.paragraphs[0].characters.length-2]));
				text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.principal"), text.paragraphs[1].characters.itemByRange(text.paragraphs[1].characters[0], text.paragraphs[1].characters[text.paragraphs[1].characters.length-2]));	
			}
		}
		else {
			if (gSet.subtitre == "") {
				text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.principal"), text.paragraphs[0].characters.itemByRange(text.paragraphs[0].characters[0], text.paragraphs[0].characters[text.paragraphs[0].characters.length-2]));	
			}
			else {
				text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.principal"), text.paragraphs[0].characters.itemByRange(text.paragraphs[0].characters[0], text.paragraphs[0].characters[text.paragraphs[0].characters.length-2]));	
				text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.surtitre"), text.paragraphs[1].characters.itemByRange(text.paragraphs[1].characters[0], text.paragraphs[1].characters[text.paragraphs[1].characters.length-2]));
			}
		}
	}
	catch (err) {
		//$.writeln(err.line + " - " + err.description);
	}

}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function CreateDialog() {
	var win = new Window("dialog", gScriptName + " - " + gScriptVersion);
	win.alignChildren = "fill";
	
	win.p1 = win.add("panel");
	win.p1.orientation = "column";
	win.p1.alignChildren = "right";
	win.p1.gr = win.p1.add("group");
	win.p1.gr.orientation = "row";
	win.p1.gr.st = win.p1.gr.add("statictext", undefined, "Titre Principal:");
	win.p1.gr.et = win.p1.gr.add("edittext", undefined, (gSet.titre != null) ? gSet.titre : "Titre Principal");
	win.p1.gr.et.preferredSize.width = 300;
	win.p1.cb = win.p1.add("checkbox", undefined, "Mince");
	win.p1.cb.value = gSet.mince;
	
	win.p2 = win.add("panel");
	win.p2.orientation = "column";
	win.p2.alignChildren = "right";
	win.p2.gr = win.p2.add("group");
	win.p2.gr.orientation = "row";
	win.p2.gr.st = win.p2.gr.add("statictext", undefined, "Surtitre:");
	win.p2.gr.et = win.p2.gr.add("edittext", undefined, (gSet.subtitre != null) ? gSet.subtitre : "Surtitre");
	win.p2.gr.et.preferredSize.width = 300;
	// Radio buttons
	win.p2.radiogr = win.p2.add("group");
	win.p2.radiogr.orientation = "column";
	win.p2.radiogr.alignment = "right";
	win.p2.radiogr.alignChildren = "left";
	win.p2.radiogr.rad1 = win.p2.radiogr.add("radiobutton", undefined, "Au-dessus le titre principal");
	win.p2.radiogr.rad2 = win.p2.radiogr.add("radiobutton", undefined, "Sous le titre principal");
	(gSet.radioBtnSelected == 1) ? win.p2.radiogr.rad1.value = true : win.p2.radiogr.rad2.value = true;	
	
	win.p3 = win.add("panel", undefined, "");
	win.p3.orientation = "column";
	win.p3.alignChildren = "right";
	win.p3.gr = win.p3.add("group");
	win.p3.gr.orientation = "row";
	win.p3.gr.st = win.p3.gr.add("statictext", undefined, "Space between text frames:");
	win.p3.gr.et = win.p3.gr.add("edittext", undefined, gSet.space);
	win.p3.gr.et.preferredSize.width = 40;
	win.p3.gr.et.onChange = function() {
		if (this.text == "") {
			this.text = gSet.space;			
		}
		else if (parseInt(this.text).toString() == "NaN") {
			alert (this.text + " is not number!");
			this.text = gSet.space;			
		}
	}
	// Keep headers
	win.p3.cb = win.p3.add("checkbox", undefined, "Gadrez les en-têtes existantes");
	if (gTitreObj != undefined || gSubtitreObj != undefined) {
		win.p3.cb.value = true;
		win.p1.cb.enabled = false;
		win.p2.radiogr.enabled = false;
		win.p3.gr.st.enabled = false;
		win.p3.gr.et.enabled = false;
	}
	else {
		win.p3.cb.enabled = false;
	}
	win.p3.cb.onClick = function() {
		if (this.value) {
			win.p1.cb.enabled = false;
			win.p2.radiogr.enabled = false;
			win.p3.gr.st.enabled = false;
			win.p3.gr.et.enabled = false;
		}
		else {
			win.p1.cb.enabled = true;
			win.p2.radiogr.enabled = true;
			win.p3.gr.st.enabled = true;
			win.p3.gr.et.enabled = true;
		}
	}

	win.p4 = win.add("panel", undefined, "Supprimer");
	win.p4.orientation = "column";
	win.p4.alignChildren = "right";
	win.p4.gr = win.p4.add("group");
	win.p4.gr.orientation = "row";
	win.p4.gr.b1 = win.p4.gr.add("button", undefined, "Surtitre");
	if (gSet.subtitre == null) win.p4.gr.b1.enabled = false;
	win.p4.gr.b1.onClick = function() {
		win.close(3);
	}
	win.p4.gr.b2 = win.p4.gr.add("button", undefined, "Cadre du Titre"); // gStory.textContainers
	if (gStory.textContainers.length < 2) win.p4.gr.b2.enabled = false;
	win.p4.gr.b2.onClick = function() {
		win.close(4);
	}
	
	// Buttons
	win.buttons = win.add("group");
	win.buttons.orientation = "row";
	win.buttons.alignment = "center";

	win.buttons.ok = win.buttons.add("button", undefined, "OK", {name:"ok" });
	win.buttons.ok.onClick = function() {
		if (win.p1.gr.et.text == "") {
			alert("\"Titre Principal\" edit field should not be empty.");
		}
		else {
			win.close(1);
		}
	}
	win.buttons.cancel = win.buttons.add("button", undefined, "Cancel", {name:"cancel"});

	var showDialog = win.show();
	
	if (showDialog == 1) {
		gSet.titre = win.p1.gr.et.text;
		gSet.subtitre = win.p2.gr.et.text;
		gSet.mince = win.p1.cb.value;
		gSet.space = win.p3.gr.et.text;
		gSet.keepExistingHeaders = win.p3.cb.value;
		(win.p2.radiogr.rad1.value) ? gSet.radioBtnSelected = 1 : gSet.radioBtnSelected = 2;
		app.insertLabel("Kas_" + gScriptName + gScriptVersion, gSet.toSource());
		Main();
	}
	else if (showDialog == 3) { // Surtitre was clicked
		RemoveSmallFrame();
		RemoveSurtitre();
	}
	else if (showDialog == 4) { // Cadre du Titre was clicked
		RemoveSmallFrame();
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ErrorExit(error, icon) {
	alert(error, gScriptName + " - " + gScriptVersion, icon);
	exit();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function GetSettings() {
	var set = eval(app.extractLabel("Kas_" + gScriptName + gScriptVersion));
	if (set == undefined) {
		set = { mince:false, radioBtnSelected:1, space:0.25, height:1 };
	}

	set.titre = set.subtitre = null;
	set.keepExistingHeaders = false;
	
	return set;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------
function GetTitres() {
	var finds;
	app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
	app.findGrepPreferences.findWhat = ".+";
	app.findGrepPreferences.appliedParagraphStyle = gTitreParStyle;
	finds = gStory.findGrep();
	if (finds.length > 0) {
		gTitreObj = finds[0];
		gSet.titre = finds[0].contents;
	}
	else {
		app.findGrepPreferences.appliedParagraphStyle = gTitreMinceParStyle;
		finds = gStory.findGrep();
		if (finds.length > 0) {
			gTitreObj = finds[0];
			gSet.titre = finds[0].contents;
		}
	}

	app.findGrepPreferences.appliedParagraphStyle = gSubtitreParStyle;
	finds = gStory.findGrep();
	if (finds.length > 0) {
		gSubtitreObj = finds[0];
		gSet.subtitre = finds[0].contents;
	}
	app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function RemoveSmallFrame() {
	var smallTf, xmlEl, parStyle;
	if (gStory.textContainers.length > 1) {
		smallTf = gStory.textContainers[0];
		xmlEl = smallTf.associatedXMLElement;
		
		if (xmlEl && xmlEl.markupTag.name == "article") {
			var xmlElPrincipal = xmlEl.xmlElements.itemByName("titre.principal");
			if (xmlElPrincipal.isValid) xmlElPrincipal.remove(); // if (xmlElPrincipal.isValid) xmlElPrincipal.remove(); if (xmlElPrincipal != null) xmlElPrincipal.remove();
			var xmlElSurtitre = xmlEl.xmlElements.itemByName("titre.surtitre");
			if (xmlElSurtitre.isValid) xmlElSurtitre.remove();  // if (xmlElSurtitre.isValid) xmlElSurtitre.remove(); if (xmlElSurtitre != null) xmlElSurtitre.remove()
		}
	
		parStyle = gStory.textContainers[1].paragraphs[0].appliedParagraphStyle;
		CleanupText(gStory);
		
		smallTf.remove();
		gTextFrame = gStory.textContainers[0];
		gTextFrame.paragraphs[0].appliedParagraphStyle = parStyle;
		gStory.recompose();
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function RemoveSurtitre() {
	var gb = gTextFrame.geometricBounds;
	var smallTextFrame = gDoc.textFrames.add({ geometricBounds:[gb[0]-gSet.height, gb[1], gb[0], gb[3]] });
	var text = smallTextFrame.texts[0];
	
	text.insertionPoints[0].contents = SpecialCharacters.FRAME_BREAK;
	text.insertionPoints[0].contents = gSet.titre;
	text.paragraphs[0].appliedParagraphStyle = (gSet.mince) ? gTitreMinceParStyle : gTitreParStyle;

	smallTextFrame.fit(FitOptions.FRAME_TO_CONTENT);
	var gb1 = smallTextFrame.geometricBounds;
	smallTextFrame.geometricBounds = [ gb[0]-(gb1[2]-gb1[0])-gSet.space, gb[1], gb[0]-gSet.space, gb[3] ];
	smallTextFrame.nextTextFrame = gTextFrame;
	
	if (text.parentStory.associatedXMLElement == null) text.parentStory.autoTag();

	try {
		text.associatedXMLElements[0].xmlElements.add(gDoc.xmlTags.item("titre.principal"), text.paragraphs[0].characters.itemByRange(text.paragraphs[0].characters[0], text.paragraphs[0].characters[text.paragraphs[0].characters.length-2]));	
	}
	catch (err) {
		//$.writeln(err.line + " - " + err.description);
	}

	// CleanupText(gTextFrame.parentStory); // gStory text
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function CleanupText(txtObj) {
	// remove return and frame break
	app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
	app.findGrepPreferences.findWhat = "(~R|\\r~R)";
	app.changeGrepPreferences.changeTo = "";
//~ 	var a1 = txtObj.findGrep();
	txtObj.changeGrep();
	
	app.findGrepPreferences.findWhat = "^\\r{1,3}";
	app.changeGrepPreferences.changeTo = "";
//~ 	var a2 = txtObj.findGrep();
	txtObj.changeGrep();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------